Arvados - Bug #12467

crunch-run not waiting for Docker image to finish loading.
10/19/2017 05:28 PM - Peter Amstutz

Status: Resolved Start date: 10/19/2017
Priority: Normal Due date:

Assigned To: Peter Amstutz % Done: 100%
Category: Estimated time: 0.00 hour
Target version: 2017-10-25 Sprint

Description

It is failing to load Docker image, even though the image load seemingly succeeds:

2017-10-19T16:41:46.528938874Z Fetching Docker image from collection '997e3bc9579153e723b599b300d9

123d+342"

2017-10-19T16:41:46.549138991Z Using Docker image id 'sha256:20a23446d37fac4cb2ec6462310aaece7119f4

594948765a3397b13f9%aec4812"
2017-10-19T16:41:46.549599576Z Loading Docker image from keep
2017-10-19T16:41:49.814403711Z Creating Docker container

2017-10-19T16:41:49.816658048Z While creating container: Error: No such image:

acd4cb2ec6462310aaee7119£4594948765a3397b13£f9%aecd812

sha256:20a23446d37f

It seems that loading is asynchronous, the ImageLoad method returns after the data has been transmitted but before the layers have

been decompressed. We need to wait for a response indicating that loading is finished.

Subtasks:
Task # 12468: Review 12467-read-imgload-response

Resolved

Associated revisions

Revision 6fdéddce - 10/19/2017 06:09 PM - Peter Amstutz
Merge branch '12467-read-imgload-response’ closes #12467

Arvados-DCO-1.1-Signed-off-by: Peter Amstutz <pamstutz@veritasgenetics.com>

History

#1 - 10/19/2017 05:38 PM - Peter Amstutz

- Description updated

#2 - 10/19/2017 05:41 PM - Peter Amstutz
- Status changed from New to In Progress

- Assigned To set to Peter Amstutz

12467-read-imgload-response @ d64215e8f0057cc7b4c6295932bc7f44d27a1eb5

#3 - 10/19/2017 05:53 PM - Tom Clegg

Better form to do "defer response.Body.Close()" before ioutil. ReadAll(), so it gets closed even if read fails.

| think the error message has copy-paste-itis: "While reading response to container image into Docker: %v"
I'm guessing it means "error reading response from docker.ImagelLoad: %v"

You don't need to say string(rbody) -- %s prints a [Jbyte as a string.

#4 - 10/19/2017 06:04 PM - Peter Amstutz

Tom Clegg wrote:

Better form to do "defer response.Body.Close()" before ioutil. ReadAll(), so it gets closed even if read fails.

| think the error message has copy-paste-itis: "While reading response to container image into Docker: %v"

I'm guessing it means "error reading response from docker.ImageLoad: %v"
You don't need to say string(rbody) -- %s prints a [Jbyte as a string.

All fixed, plus a bonus fix log.Printf -> runner.CrunchLog.Printf

12467-read-imgload-response @ a976b02dc7ecbal18277aceeaf086ab76fe4bf3f0

#5 - 10/19/2017 06:08 PM - Tom Clegg
LGTM

#6 - 10/19/2017 06:15 PM - Anonymous
- Status changed from In Progress to Resolved

- % Done changed from 0 to 100

Applied in changeset arvados|commit:6fdéddcebda57df4ecb2303dc229420c2¢c13af7b.
